#include<htc.h>
#include"header.h"
#ifndef _XTAL_FREQ
 #define _XTAL_FREQ 20000000
#endif
// button definitions. Just for info
#define btn7pH RD1
#define btn4pH RD2
#define btnMode RD3
#define led1 RC4
#define led2 RC5
#define led3 RC6
#define led4 RC7
void fnButtonInit()
{
	// Button have been initialized in sseg's file
		
	// Set LED pins as output
	TRISC=0x0F; 	// (upper 4 are LED pins)
	
	// LEDs off
	RC7=0;
	RC6=0;
	RC5=0;
	RC4=0;	
}	

//******************************************************************************
// Button debounce code
// If a button goes low,wait for 5 ms. 
// If it's still low,then again wait for the negative edge.
//******************************************************************************
char fnDebounce(char cButtId)
{
	if (cButtId==0) // 7pH
	{
		for(char i=0;i<5;i++)
			{
				__delay_ms(2);
				if(RD1==1)
				{						
					return(0);
				}	
			}
		// Now that the 7pH has been constantly low for sometime
		// wait for the negative edge.
		while(RD1==0) ;		
		// Now we have the negative edge.Good.
		// Return a "1" to indicate valid button press

		return(1);
	}
	if (cButtId==1)  // 4 pH
	{
		for(char i=0;i<5;i++)
			{
				__delay_ms(2);
				if(RD2==1)
				{						
					return(0);
				}	
			}
		// Now that the button has been constantly low for sometime
		// wait for the negative edge
		while(RD2==0) ;
		// Now we have the negative edge.Good.
		// Return a "1" to indicate valid button press
		return(1);
	}
	
	else if (cButtId==2) // Mode
	{
		for(char i=0;i<5;i++)
			{
				__delay_ms(2);
				if(RD3==1)
				{						
					return(0);
				}	
			}
		// Now that the button has been constantly low for sometime
		// wait for the negative edge
		while(RD3==0) ;
		// Now we have the negative edge.Good.
		// Return a "1" to indicate valid button press
		return(1);
	}	

	// if an invalid button code sent,just return 0
	return(0);	

}	


	
void fnMode()
	{
		
		return;		
	}
	
	