#ifndef _XTAL_FREQ
 #define _XTAL_FREQ 20000000
#endif

#define pT100Rvalue 120
#define pT100Rcoeff 2.57


// The bit patterns for '+' &'-' sign
#define cPsign 0B00111110; // b,c,g
#define cNsign 0B01111111; // only g !

//******************************************************************************
// Define global variables
//******************************************************************************

// The slope for pH calc
// Initialized to (160/3)mV/pH for ~ 25 deg C
	float pHSlope=53.333;  //(160/3);
	
// Offset storage variables
//	float gfVrefOffset=0;
	float gf7pHOffset=0;
	float gfOffsetPermV=0;


// This is the var that stores the value of "Mode"
// Since the sequence is ATC-pH-StdBy-mV
// These modes are numbered 0-1-2-3
// And we start with "Stdby" --> cMode=2
	char cMode=2;
	
// This is a flag used to implement software interrupt
// for the mode switch
// =1 means the user wants to change the mode
	char cModeFlag=0;
	
	
// Cal done storage vars; '0' means not done
	char c7pHCalDone=0;
	char cAllCalDone=0;	
	
// These var are used to smoothen out the ADC jitter
	float gfmVOldVal = 0;
	float gfpHOldVal = 0;
	
//******************************************************************************
// The var array containing the *actual* hex code sent to 7seg's data port
// Global because we need to manipulate it to display sign etc
//******************************************************************************
char gcSSEGdispHexCode[]={0,0,0,0}; // Initially,nothing to display !;

// This var aids is scrolling dashes
char gcDashPos = 0;
//******************************************************************************
// Function prototype declarations
//******************************************************************************
void fnAllLedsOff();
void fnADCInit(char,char);
int  fnADCConv32Avg();
int  fnADCConv1024Avg();
int  fnADC1024AvgUnbirdled();
void fnStartup(void);
void fnTimer_init(void);
void fnSevenSegInit(void);
void fnDelay750ms();
void fnDispNum(int);
void fnDispChar(char[4]);
void fnDispDone();
void fnDispDash();
void fnDashScroll();
void fnDispError();
void fnDelayTwoSecond(void);
void fnButtonInit();
char fnDebounce(char);
void fnMode();
void fnModeChange();
void fnCalibVRef();
void fnCalib7pH();
char fnCalib4pH();
void fnCalc_Disp_pH(int);
void fn_Calc_Disp_mV ();
void fnStdBy();
int  fnCalcTempPt100();
void fnSetpHSlope(int);


//******************************************************************************
// Fill first 8 bytes of EEPROM with '0'
// Generally,filling up entire EEPROM with '0' avoids certain issues
// when your program is using EEPROM
//******************************************************************************
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

