#include <htc.h>	// Required to interface with delay routines

//#include	<stdlib.h>
#include"header.h"


//******************************************************************************
// The single most important line. It sets the configuration word register.
// I wasted an entire day because my programmer couldn't get it right !
// Change it ONLY IF YOU KNOW WHAT YOU ARE DOING !!!
//******************************************************************************
__CONFIG(0x1E32);
//******************************************************************************
// Now begins life.
//******************************************************************************
void main(void){
			
	// Here goes the startup code
	fnStartup();

//******************************************************************************
//	Let's first calib the 1v and 3v references
//******************************************************************************
	//fnADCInit(5,'3');
	//gfVrefOffset = (614- fnADCConv1024Avg())*5;
//******************************************************************************
// Let's proceed with the infinite loop
// It polls the inputs (button) and calls the aproporiate functions	
//******************************************************************************

	while(1)
		{
			// First poll 7pH
			if(RD1==0)
				{				
					if(fnDebounce(0)) // check debounce. "0" means "7pH"
					{
						fnCalib7pH();
						
						// Calib done. So set/reset the var and display done
						c7pHCalDone=1; // 7pH done
						cAllCalDone=0; // 4pH still needs be done
						// display "donE"
						fnDispDone();
						fnDelayTwoSecond();	
					}	

				}	
			if(RD2==0)   // check 4pH
				{				
					if(fnDebounce(1)) // check debounce. "1" means "4pH"
					{
						// run 4pH cal only if 7pH has been done
						if((c7pHCalDone==1)&&(cAllCalDone==0))
						{
							char cCheck=fnCalib4pH();
							
							if(cCheck == 0)			 // when calib successful,0 is returned
							{
								fnDispDone();
								fnDelayTwoSecond();	
							}
							else if(cCheck == 1)	// 4pH calib unsuccessful. Disp error
							{
									fnDispError();
									fnDelayTwoSecond();
							}
							
							// now that all cal done,set var !
								cAllCalDone=1;			
						}
					}
				}
				
				// poll Mode
			if(RD3==0)
				{				
					if(fnDebounce(2)) // check debounce. "2" means "Mode.
					{	
						// check if we were at highest value
						if(cMode==3)
						{
							cMode=1;
						}
						else
						{
							cMode++;
						}
					}
				}
				
		// P.S - Polling mode won't work when called from ADC 
		// routines because that'll quickly overflow the stack
		// (figure it out yourself). So have copy-pasted 
		// it there after editing.
				
		
		// Now work acc. to mode
					switch(cMode)							
					{
						case(0): 	// 0=ATC
									//since there is no ATC,we'll go to manual !
									cMode=1;
						break;
						case(1): 	// Manual pH
									// LEDs !
									fnAllLedsOff();	
									RC4=1;// 1= manual pH
									fnADCInit(5,'p');	
									int iTem = ((fnADCConv32Avg()/10));									
									fnCalc_Disp_pH (iTem);								
						break;
						case(2): 	// 2=stdby
									fnStdBy();
						break;
						case(3): 	 // 3=mV
									fn_Calc_Disp_mV ();
						break;
						default:
						break;
					}
					
	}		
}



void fnCalc_Disp_pH (int itempe)
{
	// Now Calc ph !
	fnADCInit(5,'h');	
	
	float fpHread=0;
	
	for(char k=0;k<32;k++)
	{	
		fpHread=fpHread+fnADCConv1024Avg();
		
		// before going any further,check if the mode flag was raised
		// if yes,then just return to the calling function	
		if(cModeFlag==1)
		{
			cModeFlag=0; // reset flag for future use
			return;
		}		
		
	}
	
	// Average of the averages
	fpHread=((int)fpHread>>5);
	
	// Now that we have the average of thousands of readings
	// Lets interpret it !	
	// convert to mV 
	fpHread=(((fpHread/1023)*(5000)))/5; 
	// Calc actual mV (since sensor's ground is raised by 0.5V)
	fpHread=fpHread-500;
	//******************************************************************
	// COMPENSATE FOR 0mV OFFSET
	//******************************************************************
	
	
		//******************************************************************
		// THE BELOW CODE COMMENTED OUT AS IT COMPENSATES BY AFTER
		// CONSIDERING THE OFFSET POLARITY
		// IN THE LATEST READINGS,I'VE FOUND OUT THAT THE OFFSET REAMINS MORE OR LESS
		// THE SAME FOR -VE OR +VE READINGS. MORE IMPORTANTLY,THE Pt100 INJECTS A STEADY OFSET OF ABOUT 28mV 
		// AND THAT HAS TO BE COMPENSATED FOR EVERY WHERE
		// SO JUST SUBTRACT THE 0mV OFFSET FROM ALL READINGS !!!
	/* Generally,the 0mV offset is +ve and is not reflected in basic sol.
		 But , hypothetically,there could be a scenario where this was -ve
	 	So we check the offset first. If it's positive,then we applyy it 
	 	only to +ve mV values (acids)
	 	Else we apply it ONLY to -ve mV (basic sol) 
	
	if(		gf7pHOffset > 0		)
	{
		if(fpHread > 0)
		{
			fpHread=fpHread - gf7pHOffset ;
		}	
	}
	else if(		gf7pHOffset < 0		)
	{
		if(fpHread < 0)
		{
			fpHread=fpHread - gf7pHOffset ;	
		}	
	}
	*/	
	
	
	
	fpHread=fpHread - gf7pHOffset ;	
		
					
	//******************************************************************
	// COMPENSATE FOR 4 pH OFFSET WHICH IS ACTUALLY THE TEMP OFFSET
	// This,again,has to be done for all values !!!
	//******************************************************************	

			fpHread=fpHread + (fpHread*gfOffsetPermV) ;

	/*
	// Smoothen out the jitter
	// If new reading is less than old one,then display the old one itself
	// but also store the new reading
	if (fpHread < gfpHOldVal)
		{ 
			float fTempVar=fpHread; // temp. store new reading
			fpHread=gfpHOldVal;  // New reading is less. So replace it with old reading
			gfpHOldVal = fTempVar; // Insert new reading as the next "old reading"
		}
	else
		{	gfpHOldVal=fpHread ; }	
			
		*/
	//******************************************************************
	//  Temperature compensation
	//******************************************************************
	fnSetpHSlope(itempe);

	
	// CODE FOR "BANDING"
	// "band" for 7 pH
	if((fpHread > (-2))&&(fpHread < (2)))
		{ fpHread = 0 ; }
		
	// "band" for 4 pH
	float f4Band = (3*pHSlope);	
	if( (fpHread >(f4Band-2))  &&  (fpHread<(f4Band+2)) )
		{ fpHread = f4Band ; }		
		
	// "band" for 9.18 pH
//	float f9Band = -(2.18*pHSlope);	
//	if( (fpHread >(f9Band-6))  &&  (fpHread<(f9Band+6)) )
//		{ fpHread = f9Band ; }
	
	
	
	// display in .01 * pH	
	fpHread =((7-(fpHread/pHSlope))*100);	

	// Display pH
	fnDispNum(fpHread);
	// Add the decimal point
	gcSSEGdispHexCode[2]=(gcSSEGdispHexCode[2])&(0B11111011);
		
	// Disable the highest 7seg if ph<10
	if ( fpHread < (1000) )
			gcSSEGdispHexCode[3]=0xff;	

}	


void fnStdBy() 
{	
	// LEDs !
	fnAllLedsOff();	
	RC5=1;
	
	// We're in standby. So just display 4 zeroes
	fnDispNum(0);

}


void fn_Calc_Disp_mV ()
{
	// LEDs !
	fnAllLedsOff();
	RC6=1;	
	// Placeholder for the sign pattern
	char cDispSign=0xFF;




fnADCInit(5,'h');

	float fmVread=0;
	
	for(char k=0;k<32;k++)
	{	
		fmVread=fmVread+fnADCConv1024Avg();
		
		// before going any further,check if the mode flag was raised
		// if yes,then just return to the calling function	
		if(cModeFlag==1)
		{
			cModeFlag=0; // reset flag for future use
			return;
		}		
		
	}
	
	// Average of the averages
	fmVread=((int)fmVread>>5);
	
	// Now that we have the average of thousands of readings
	// Lets interpret it !	
	// convert to mV 
	fmVread=(((fmVread/1023)*(5000)))/5; 
	// Calc actual mV (since sensor's ground is raised by 0.5V)
	fmVread=fmVread-500;
	//******************************************************************
	// COMPENSATE FOR 0mV OFFSET
	//******************************************************************
	
fmVread=fmVread - gf7pHOffset ;	
		
					
	//******************************************************************
	// COMPENSATE FOR 4 pH OFFSET WHICH IS ACTUALLY THE TEMP OFFSET
	// This,again,has to e done for all values !!!
	//******************************************************************	

fmVread=fmVread + (fmVread*gfOffsetPermV) ;
/*	if(fmVread > 0)
		{
			fmVread=fmVread + (fmVread*gfOffsetPermV) ;
		}
		
	else if(fmVread < 0)
		{
			fmVread=fmVread - (fmVread*gfOffsetPermV) ;
		}*/
	
	/*
	
	// Smoothen out the jitter
	// If new reading is less than old one,then display the old one itself
	// but also store the new reading
	if (fmVread < gfmVOldVal)
		{ 
			float fTempVar=fmVread; // temp. store new reading
			fmVread=gfmVOldVal;  // New reading is less. So replace it with old reading
			gfmVOldVal = fTempVar; // Insert new reading as the next "old reading"
		}
	else
		{	gfmVOldVal=fmVread ; }	
			
*/
	// CODE FOR "BANDING"
	// "band" for 7 pH
	if((fmVread > (-2))&&(fmVread < (2)))
		{ fmVread = 0 ; }
		
	// "band" for 4 pH
	float f4Band = (3*pHSlope);	
	if( (fmVread >(f4Band-2))  &&  (fmVread<(f4Band+2)) )
		{ fmVread = f4Band ; }		
		
	// "band" for 9.18 pH
//	float f9Band = -(2.18*pHSlope);	
//	if( (fmVread >(f9Band-6))  &&  (fmVread<(f9Band+6)) )
//		{ fmVread = f9Band ; }
	






	
	
	// set sign
	if (fmVread == 0)
	{	cDispSign = 0xff;		}		// If 0mV , then why disp sign ?
	else if(fmVread > 0)
		{	cDispSign=0xFF; }
	else
		{
			cDispSign=cNsign;
			fmVread=-(fmVread);
		}
	
	// Display mV
	fnDispNum(fmVread);
	
	// Display the sign
	gcSSEGdispHexCode[3]=cDispSign;
}



	
//******************************************************************************
// Startup Code;contains variables etc declared in other files.
// So don't get baffled,just check the name of the var and look up the 
// file corresponding to it's module
//******************************************************************************
void fnStartup()
{		
	fnTimer_init(); // found in the 7segment's .c file
	fnSevenSegInit(); // found in the 7segment's .c file
	// PUT CODE HERE FOR ADC INIT
	
	// Init inputs and their LEDs
	fnButtonInit(); //found in button's .c file
	
	// Initialize the Pt100's gnd pin as output
	TRISA4=0;
	
	// Initialise unused pins as output (@ ground)
	TRISC0=0;   RC0=0;
	TRISC1=0;   RC1=0;
	TRISC2=0;   RC2=0;
	TRISC3=0;   RC3=0;
	TRISD0=0;	RD0=0;	
	TRISE0=0;	RE0=0;	
	TRISE1=0;	RE1=0;
}


//******************************************************************************
// Generate delays,mostly for UI tasks
//******************************************************************************	
void fnDelayTwoSecond()
{
	for (char i=0;i<40;i++)
	{
		__delay_ms(50);
	}
}

void fnDelay750ms()
{
	for (char i=0;i<150;i++)
	{
		__delay_ms(50);
	}
}

//******************************************************************************
// This turns off all leds ; useful for mode switching
//******************************************************************************	
void fnAllLedsOff()
{
	RC4=0;
	RC5=0;
	RC6=0;
	RC7=0;
}
	