#include <htc.h>	// Required to interface with delay routines
#include "header.h"
//******************************************************************************
// 7 Segment definitions
// This is a FIVE SEGMENT DISPLAY
// The lowest order LED bieng numbered ONE
// And the highest one FIVE
//******************************************************************************
// 7Segment's "data" port. This defnition is critical.
#define SSEGdataPORT PORTB
// 7Segment's "data" lines.Only for Information
#define SSEGaPIN  RB2	
#define SSEGbPIN  RB1
#define SSEGcPIN  RB6
#define SSEGdPIN  RB5
#define SSEGePIN  RB4
#define SSEGfPIN  RB0
#define SSEGgPIN  RB3


// Now defining the parameters for the "strobe" linesOnly for Information
#define SSEG0StrobePIN RD7
#define SSEG1StrobePIN RD6
#define SSEG2StrobePIN RD5
#define SSEG3StrobePIN RD4



//******************************************************************************
// The var that tells timer "which 7seg to light up?"
//******************************************************************************
char gcDispLedCount;
//******************************************************************************


void interrupt timer0_isr(void)
{
	// if you're here because of ADC interrupt,go back !
	if(ADIF==1)
	{
		ADIF=0;		
	}	
	else
	{
		T0IF = 0; // CLEAR FLAG AS IT MUST BE DONE MANUALLY
			
	//******************************************************************************
	// Check which 7seg to light up and activate it's "strobe" pin
	// Also reset the counter,if it has reached 3.
	//******************************************************************************
		if(gcDispLedCount < 3)
			{ gcDispLedCount++; }
		else
			{gcDispLedCount=0;}
			
			
		switch(gcDispLedCount)
		{
			case(0) : 
						
						RD4=0;		   
						RD7=1;
			break;
			case(1) : 
						RD7=0;
						RD6=1;
			break;
			case(2) : 
						RD6=0;
						RD5=1;
			break;
			case(3) : 
						RD5=0;
						RD4=1; 
	
			break;
			default : 	break;
		}
	}		
	
	
//******************************************************************************
//  Now put the hex code onto the data port.This completes the ISR
//******************************************************************************
	SSEGdataPORT=gcSSEGdispHexCode[gcDispLedCount];		

}



void fnDispNum(int num)
{	
// First break apart the given integer into separete digits
// and write them to a temporary array i.e. digits[]
   char digits[]={0,0,0,0};
   char i=0;
   
   if(num>9999) // Restrict number to 9999
   { num=1; }
   
   while(num)	// Now break it
   {
      digits[i]=num%10;
      i++;

      num=num/10;
   }
   
// Now that you have the number,put it into the display array !
   for (i=0;i<4;i++)
   {	   
	   switch(digits[i])
	   {
	      case 0:
	      	      	//     abcdef	
	         gcSSEGdispHexCode[i]= 0B10000100;
	         break;
	
	      case 1:
	               //      bcg
	         gcSSEGdispHexCode[i]= 0B10111110;
	         break;
	
	      case 2:
	               //      abdeg	
	         gcSSEGdispHexCode[i]= 0B00010101;
	         break;
	
	      case 3:
	               //      abcdg
	         gcSSEGdispHexCode[i]= 0B00011100;
	         break;
	
	      case 4:
	               //      bcfg
	         gcSSEGdispHexCode[i]= 0B00101110;
	         break;
	
	      case 5:
	               //      acdfg
	         gcSSEGdispHexCode[i]= 0B01001100;
	         break;
	
	      case 6:
	               //      acdefg	
	         gcSSEGdispHexCode[i]= 0B01000100;
	         break;
	      case 7:
	               //      abc
	         gcSSEGdispHexCode[i]= 0B10011110;
	         break;
	
	      case 8:
	               //      all !	
	         gcSSEGdispHexCode[i]= 0B00000100;
	         break;
	
	      case 9:
	               //      abcfg
	         gcSSEGdispHexCode[i]= 0B00001110;
	         break;
	   }
	  } 
	   // Now that the number has been broken down and it's numerals
	   // placed in the display array,it will automatically be displayed.
	   // So this function's job ends here!
}



// I havn't figured out how to pass a string in HITECH C. Hence have used the fnDispDone()
// and fnDispDash(). Still,this general purpose function is here for legacy.
void fnDispChar(char acDispChar[])
{	
// Fill the display array according to the given characters
// The character '_' is used to denote space ( blank 7 segment)
char i=0;
   for (i=0;i<4;i++)
   {	   

	if (acDispChar[i]=='_')
	   {
		   gcSSEGdispHexCode[i]=0xFF; // "_" means blank !
	    	}
	else if(acDispChar[i]=='-')
	   {
		   gcSSEGdispHexCode[i]=0b01111110; // "g" only
		  }
	else if (acDispChar[i]=='D')
	   {
		   gcSSEGdispHexCode[i]=0b00001100; // bcdeg
		  }
	else if (acDispChar[i]=='O')
	   {
		   gcSSEGdispHexCode[i]=0b00001110; // cdeg
		  }
	else if (acDispChar[i]=='N')
	   {
		   gcSSEGdispHexCode[i]=0b00101110; // ceg
		  }
	else if (acDispChar[i]=='E')
	   {
		   gcSSEGdispHexCode[i]=0b01000010; // 0abcdefg
		  }
	else if (acDispChar[i]=='P')
	   {
		   gcSSEGdispHexCode[i]=0b0110000; // abefg
		  }
	else if (acDispChar[i]=='H')
	   {
		   gcSSEGdispHexCode[i]=0b00000111; // cdef
		  }
// Numerals '7' and '4' included for use in ph meter

	else if (acDispChar[i]=='4')
	   {
		   gcSSEGdispHexCode[i]= 0B00110100;
		  }
	else if (acDispChar[i]=='7')
	   {
		   gcSSEGdispHexCode[i]= 0B00111001;
		  }		  

	}
	   // Now that the character's corresponding code have been
	   // placed in the display array,it will automatically be displayed.
	   // So this function's job ends here!

}

void fnDispDone()
{
	gcSSEGdispHexCode[3]=0b00110100; // 'd'
	gcSSEGdispHexCode[2]=0b01110100; //
	gcSSEGdispHexCode[1]=0b01110110; //
	gcSSEGdispHexCode[0]=0b01000101; // 
}

void fnDispDash()
{
	gcSSEGdispHexCode[0]=0b01111111; // "-" ="g" only
	gcSSEGdispHexCode[1]=0b01111111; // 	"g" only
	gcSSEGdispHexCode[2]=0b01111111; // 	"g" only
	gcSSEGdispHexCode[3]=0b01111111; // 	"g" only
}

void fnDashScroll()
{
	// First turn everything off
	gcSSEGdispHexCode[0]=0xff;
	gcSSEGdispHexCode[1]=0xff;
	gcSSEGdispHexCode[2]=0xff;
	gcSSEGdispHexCode[3]=0xff;
	
	// now display dash
	gcSSEGdispHexCode[gcDashPos] = 0b01111111; // "-" ="g" only
	
	
	if (gcDashPos == 3)
		{ gcDashPos=0;}
	else
		{ gcDashPos++;}
}	
void fnTimer_init()
{
	// Timer0 (8 bit) being used alongwith prescaler for charlieplexing
	// Uses interrupts to periodically change the display
					
		T0CS=0; // timer (NOT COUNTER) mode on
		PSA=0;  // PRESCALER TO TIMER0
		PS0=1;  // "011" MEANS A PRESCALER OF 16
		PS1=1;  // This prescaler divides the system clock
		PS2=0;  // So on a 20Mhz crystal, we will have a final clock of (20/4/16) Mhz
		T0IE = 1;			// enable timer interrupt
		GIE = 1;			// enable global interrupts
}


void fnSevenSegInit()
{
	// Initialize the ports used for 7 segments
	// Set data lines as output
	TRISB=0x00;
	// Initially,display is blank
	PORTB=0xFF;
			
	// Set strobe lines as output & button lines as input
	TRISD=0x0F;
	// Initially no line selected
	PORTD=0x00;	

	// Now initializing the variables !
	gcDispLedCount=0;    // Because first we start with 7seg at unit place	
	
}	


void fnDispError()
{
	// used to disp "EEEE" in case of error
	gcSSEGdispHexCode[3]=0b01000101; // 'E'
	gcSSEGdispHexCode[2]=0b01110111;; // 'r'
	gcSSEGdispHexCode[1]=0b01110011; // 'r.'
	gcSSEGdispHexCode[0]=0b11111111; // '.'
}	




